/// <reference types="@project-serum/anchor/node_modules/@solana/web3.js" />
import { PublicKey, Keypair } from '@solana/web3.js';
import { CypherClient } from '../client';
import { CacheAccountState, StateUpdateHandler, Cache, CacheListenerCB, ErrorCB } from '../types';
export declare class CacheAccount {
    readonly client: CypherClient;
    readonly address: PublicKey;
    state: CacheAccountState;
    private _onStateUpdate?;
    private _errorCallback?;
    private _listener;
    private _cacheListeners;
    constructor(client: CypherClient, address: PublicKey, state: CacheAccountState, _onStateUpdate?: StateUpdateHandler<CacheAccountState>, _errorCallback?: ErrorCB);
    static create(client: CypherClient, clearing: PublicKey, authority: PublicKey): Promise<{
        cacheAccount: PublicKey;
        ixs: import("@solana/web3.js").TransactionInstruction[];
        signers: Keypair[];
    }>;
    private get connection();
    static load(client: CypherClient, address: PublicKey, onStateUpdateHandler?: StateUpdateHandler<CacheAccountState>, errorCallback?: ErrorCB): Promise<CacheAccount>;
    getCaches(): Cache[];
    getCache(idx: number): Cache;
    addCacheListener(callback: CacheListenerCB, idx: number, errorCallback: ErrorCB): void;
    removeCacheListener(idx: number): void;
    subscribe(): void;
    private addListener;
    private removeListener;
    unsubscribe(): Promise<void>;
}
