import { PublicKey } from '@solana/web3.js';
import { Pool } from './pool';
import { CypherClient } from '../client';
import type { CreatePerpetualMarketArgs, ErrorCB, PerpetualMarketState, StateUpdateHandler } from '../types';
export declare class PerpetualMarket {
    readonly client: CypherClient;
    readonly address: PublicKey;
    state: PerpetualMarketState;
    private _onStateUpdate?;
    private _errorCallback?;
    private _listener;
    constructor(client: CypherClient, address: PublicKey, state: PerpetualMarketState, _onStateUpdate?: StateUpdateHandler<PerpetualMarketState>, _errorCallback?: ErrorCB);
    static create(client: CypherClient, authority: PublicKey, clearing: PublicKey, cacheAccount: PublicKey, quotePool: Pool, oracleProducts: PublicKey, args: CreatePerpetualMarketArgs): Promise<PublicKey>;
    static load(client: CypherClient, address: PublicKey, onStateUpdateHandler?: StateUpdateHandler<PerpetualMarketState>, errorCallback?: ErrorCB): Promise<PerpetualMarket>;
    static loadAll(client: CypherClient): Promise<PerpetualMarket[]>;
    subscribe(): void;
    private addListener;
    private removeListener;
    unsubscribe(): Promise<void>;
}
