/// <reference types="@project-serum/anchor/node_modules/@solana/web3.js" />
import { Keypair, PublicKey, TransactionInstruction } from '@solana/web3.js';
import type { Cluster, Wallet } from '../types';
export declare class FaucetClient {
    private _cluster;
    private _program;
    constructor(_cluster: Cluster, rpcEndpoint: string, wallet: Wallet, confirmOpts?: import("@solana/web3.js").ConfirmOptions);
    static get quoteMintAddrFull(): Keypair;
    static deriveFaucetAddress(cluster: Cluster, mint: PublicKey): PublicKey;
    static deriveMintAuthority(cluster: Cluster, mint: PublicKey): [PublicKey, number];
    private get _provider();
    private get _walletPubkey();
    initFaucet(mint: Keypair, decimals: number): Promise<string>;
    getRequestInstr(mint: PublicKey, target: PublicKey): Promise<TransactionInstruction>;
    mint(mint: PublicKey): Promise<string>;
}
