import { Transaction, TransactionInstruction, Signer, ConfirmOptions, Connection } from '@solana/web3.js';
import { AccountNamespace, AnchorProvider, MethodsNamespace, Program } from '@project-serum/anchor';
import { FaucetClient } from './faucet';
import type { Cypher } from '../generated/types/cypher';
import type { Cluster, Wallet } from '../types';
import { PublicKey } from '@solana/web3.js';
export declare class CypherClient {
    readonly cluster: Cluster;
    program: Program<Cypher>;
    faucet: FaucetClient;
    constructor(cluster: Cluster, rpcEndpoint: string, wallet?: Wallet, confirmOpts?: ConfirmOptions);
    connectWallet(wallet: Wallet, rpcEndpoint: string, confirmOpts?: ConfirmOptions): void;
    private get _provider();
    get anchorProvider(): AnchorProvider;
    get connection(): Connection;
    get methods(): MethodsNamespace<Cypher>;
    get accounts(): AccountNamespace<Cypher>;
    get isWalletConnected(): boolean;
    get walletPubkey(): PublicKey;
    get cypherPID(): PublicKey;
    get dexPID(): PublicKey;
    get quoteMint(): PublicKey;
    addEventListener(eventName: string, callback: (event: any, slot: number) => void): number;
    removeEventListener(listener: number): Promise<void>;
    sendAndConfirm(tx: Transaction, signers?: Signer[], opts?: ConfirmOptions): Promise<string>;
    sendAndConfirmIxs(ixs: TransactionInstruction[], signers?: Signer[], opts?: ConfirmOptions): Promise<string>;
}
