import { PublicKey } from '@solana/web3.js';
import { BN } from '@project-serum/anchor';
export declare const getDexVaultSigner: (dexMarket: PublicKey, vaultSignerNonce: BN, dexPID: PublicKey) => PublicKey;
export declare const derivePublicClearingAddress: (cypherPID: PublicKey) => [PublicKey, number];
export declare const derivePrivateClearingAddress: (clearingNumber: number, cypherPID: PublicKey) => [PublicKey, number];
export declare const derivePoolAddress: (poolName: number[], cypherPID: PublicKey) => [PublicKey, number];
export declare const derivePoolNodeAddress: (pool: PublicKey, nodeNumber: number, cypherPID: PublicKey) => [PublicKey, number];
export declare const derivePoolNodeVaultAddress: (poolNode: PublicKey, cypherPID: PublicKey) => [PublicKey, number];
export declare const derivePoolNodeVaultSigner: (poolNode: PublicKey, cypherPID: PublicKey) => [PublicKey, number];
export declare const deriveMarketAddress: (marketName: number[], cypherPID: PublicKey) => [PublicKey, number];
export declare const deriveOracleProductsAddress: (symbol: number[], cypherPID: PublicKey) => [PublicKey, number];
export declare const deriveAccountAddress: (authority: PublicKey, accountNumber: number, cypherPID: PublicKey) => [PublicKey, number];
export declare const deriveSubAccountAddress: (masterAccount: PublicKey, accountNumber: number, cypherPID: PublicKey) => [PublicKey, number];
export declare const deriveOrdersAccountAddress: (masterAccount: PublicKey, market: PublicKey, cypherPID: PublicKey) => [PublicKey, number];
export declare const deriveSerumOrdersAccountAddress: (dexMarket: PublicKey, masterAccount: PublicKey, subAccount: PublicKey, cypherPID: PublicKey) => [PublicKey, number];
