"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.repeatWhenFailed = void 0;
const shared_1 = require("./shared");
const repeatWhenFailed = (call, timeout, fnName = 'Unknown asycn function call') => {
    return async (x) => {
        try {
            return await call(x);
        }
        catch (err) {
            console.log(`${fnName} failed! repeating in ${timeout} ms...`);
            console.error(err);
            await (0, shared_1.sleep)(timeout);
            const repeater = (0, exports.repeatWhenFailed)(call, timeout, fnName);
            return await repeater(x);
        }
    };
};
exports.repeatWhenFailed = repeatWhenFailed;
//# sourceMappingURL=request.js.map