/// <reference types="bn.js" />
import { I80F48 } from '@blockworks-foundation/mango-client';
import { BN } from '@project-serum/anchor';
import { Side } from '../types/on-chain';
export declare function getSideFromKey(orderId: BN): Side;
export declare function sizeLotsToNative(sizeLots: BN, baseMultiplier: BN): BN;
export declare function priceLotsToNative(priceLots: BN, baseMultiplier: BN, quoteMultiplier: BN, decimals: number): BN;
export declare function fp32Mul(a: BN, bFp32: BN): BN;
export declare function getQuoteFromBase(baseAmount: BN, scaledPriceFp32: BN, baseMultiplier: BN, quoteMultiplier: BN): BN;
export declare function splToUiAmount(splAmount: BN, decimals: number): number;
export declare function splToUiAmountFixed(splAmount: I80F48, decimals: number): I80F48;
export declare function splToUiPrice(splPrice: BN, baseDecimals: number, quoteDecimals: number): number;
export declare function uiToSplAmount(uiAmount: number, decimals: number): BN;
export declare function uiToSplAmountFixed(uiAmount: number, decimals: number): I80F48;
export declare function uiToSplPrice(uiPrice: number, baseDecimals: number, quoteDecimals: number): BN;
